package com.covas.ApplicationScoped;


import org.jboss.logging.Logger;

import io.quarkus.runtime.ShutdownEvent;
import io.quarkus.runtime.StartupEvent;

import java.time.LocalDate;
import java.time.Month;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.event.Observes;
import javax.inject.Inject;
import javax.transaction.Transactional;

import com.covas.Entity.UsersEntity;
import com.covas.Enums.Roles;

import org.eclipse.microprofile.config.inject.ConfigProperty;


@ApplicationScoped
public class ApplicationLifeCycle {
    @Inject
    @ConfigProperty(name = "covas.schema.create", defaultValue = "true") 
    boolean schemaCreate;

    private static final Logger LOGGER = Logger.getLogger(ApplicationLifeCycle.class);

    @Transactional
    void onStart(@Observes StartupEvent ev) {
        LOGGER.info("The application has started");
        if (schemaCreate){  
            UsersEntity users = new UsersEntity();
            UsersEntity users2 = new UsersEntity();

            
            if(users.findByPseudo("Peter") == null){
                users.pseudo = "Peter";
                users.email = "peter@email.com";
                users.name = "Toto";
                users.firstName = "Peter";
                users.birth = LocalDate.of(1993, Month.FEBRUARY, 23);
                users.status = true;
                users.password = "toto";
                users.roles = Roles.User;
                users.persist();
                LOGGER.info("Peter test was created");
            } else {
                LOGGER.info("Peter's user test wasn't created");
            }
            if(users2.findByPseudo("Robert") == null){
                users2.pseudo = "Robert";
                users2.email = "robert@email.com";
                users2.name = "Toto";
                users2.firstName = "Peter";
                users2.birth = LocalDate.of(1993, Month.FEBRUARY, 23);
                users2.status = true;
                users2.password = "toto";
                users2.roles = Roles.Admin;
                users2.persist();
                LOGGER.info("Robert test was created");
            } else {
                LOGGER.info("Robert's user test wasn't created");
            }
        } else {
            LOGGER.info("DB init wassn't created");
        }  
    }
    void onStop(@Observes ShutdownEvent ev) {
        LOGGER.info("The application is stopping...");
    }
    
}
